]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- noet
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
cd445739
AM
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
ac1516e0 25v0.17 (C) 1999-2006 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
47761337 40NOINIT=""
cd445739 41UPDATE=""
cd445739
AM
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
d1c5a9a7 64RPMBUILDOPTS=""
cd445739
AM
65BCOND=""
66GROUP_BCONDS="no"
947025e5 67CVSIGNORE_DF="no"
d287305c 68
69PATCHES=""
70SOURCES=""
cd445739 71ICONS=""
d287305c 72PACKAGE_RELEASE=""
73PACKAGE_VERSION=""
74PACKAGE_NAME=""
cd445739
AM
75PROTOCOL="ftp"
76WGET_RETRIES=${MAX_WGET_RETRIES:-0}
77CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
78
79CVSTAG=""
80RES_FILE=""
39dcc7de 81CVS_FORCE=""
cd445739
AM
82
83CVS_SERVER="cvs.pld-linux.org"
84DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 85ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 86
36d03934 87DEF_NICE_LEVEL=19
86aafdbe 88SCHEDTOOL="auto"
cd445739
AM
89
90FAIL_IF_NO_SOURCES="yes"
91
18e5347d
ER
92# let get_files skip over files which are present to get those damn files fetched
93SKIP_EXISTING_FILES="no"
94
975d7b23 95TRY_UPGRADE=""
257af81b
ER
96# should the specfile be restored if upgrade failed?
97REVERT_BROKEN_UPGRADE="yes"
98
ab4a2b6e 99if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 100 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 101else
ce40491a 102 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
103fi
104
cd445739
AM
105# Here we load saved user environment used to
106# predefine options set above, or passed to builder
107# in command line.
108# This one reads global system environment settings:
109if [ -f ~/etc/builderrc ]; then
110 . ~/etc/builderrc
111fi
112# And this one cascades settings using user personal
113# builder settings.
114# Example of ~/.builderrc:
115#
116#UPDATE_POLDEK_INDEXES="yes"
117#FETCH_BUILD_REQUIRES="yes"
118#REMOVE_BUILD_REQUIRES="force"
119#GROUP_BCONDS="yes"
120#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 121#TITLECHANGE=no
cd445739 122#
a83e5405 123SU_SUDO=""
cd445739
AM
124if [ -n "$HOME_ETC" ]; then
125 USER_CFG="$HOME_ETC/.builderrc"
126else
127 USER_CFG=~/.builderrc
128fi
129
130[ -f "$USER_CFG" ] && . "$USER_CFG"
131
86aafdbe
ER
132if [ "$SCHEDTOOL" = "auto" ]; then
133 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
134 SCHEDTOOL="schedtool -B -e"
135 else
136 SCHEDTOOL="no"
137 fi
138fi
139
ca2e6c31 140if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
141 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
142 GETURI2="$GETURI"
143 OUTFILEOPT="-O"
ca2e6c31 144elif [ -n "$USE_AXEL" ]; then
cede92b3 145 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
146 GETURI2="$GETURI"
147 OUTFILEOPT="-o"
ca2e6c31 148else
5700ee32
ER
149 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
150 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
151 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 152
7e365483
KK
153 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
154 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
155 OUTFILEOPT="-O"
2bc5451f 156fi
11468b23 157
11468b23
AM
158GETLOCAL="cp -a"
159
160if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
161 RPM="rpm"
162 RPMBUILD="rpm"
163else
164 RPM="rpm"
165 RPMBUILD="rpmbuild"
166fi
167
168POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 169POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 170
cd445739
AM
171run_poldek()
172{
173 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
174 if [ -n "$LOGFILE" ]; then
175 LOG=`eval echo $LOGFILE`
176 if [ -n "$LASTLOG_FILE" ]; then
177 echo "LASTLOG=$LOG" > $LASTLOG_FILE
178 fi
86aafdbe 179 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
180 return $exit_pldk
181 else
86aafdbe 182 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
183 return `cat ${RES_FILE}`
184 rm -rf ${RES_FILE}
185 fi
186}
187
cd445739
AM
188#---------------------------------------------
189# functions
da946cd6 190
5a491465 191usage()
192{
cd445739
AM
193 if [ -n "$DEBUG" ]; then set -xv; fi
194 echo "\
195Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
6594293d 196[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 197[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 198[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
199[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 200[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 201[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d
AG
202[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
203[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
204<package>[.spec][:cvstag]
2a5f078d 205
cd445739
AM
206-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
207-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
208-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
209-D, --debug - enable builder script debugging mode,
210-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
211-V, --version - output builder version
212-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
213-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
214 from <package>.spec,
215-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
216 only package from <package>.spec,
c56807e0 217-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
218-bc - execute the %build phase of <package>.spec,
219-bi - execute the %install phase of <package>.spec
220-bl - execute the %files phase of <package>.spec
cd445739
AM
221-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
222 them into src.rpm,
6594293d 223--short-circuit - short-circuit build
cd445739
AM
224-B, --branch - add branch
225-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
226 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 227-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 228-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
229 - setup \$CVSROOT,
230--define <macro> <value>
231 - define a macro <macro> with value <value>,
232--nodeps - rpm won't check any dependences
233-g, --get - get <package>.spec and all related files from CVS repo
234 or HTTP/FTP,
235-h, --help - this message,
236--http - use http instead of ftp,
237-l <logfile>, --logtofile <logfile>
238 - log all to file,
239-m, --mr-proper - only remove all files related to spec file and all work
240 resources,
241-nc, --no-cvs - don't download sources from CVS, if source URL is given,
242-ncs, --no-cvs-specs
243 - don't check specs in CVS
244-nd, --no-distfiles - don't download from distfiles
245-nm, --no-mirrors - don't download from mirror, if source URL is given,
246-nu, --no-urls - don't try to download from FTP/HTTP location,
247-ns, --no-srcs - don't download Sources
248-ns0, --no-source0 - don't download Source0
249-nn, --no-net - don't download anything from the net
b572253e 250--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
251-ske,
252--skip-existing-files - skip existing files in get_files
cd445739
AM
253--opts <rpm opts> - additional options for rpm
254-q, --quiet - be quiet,
255--date yyyy-mm-dd - build package using resources from specified CVS date,
256-r <cvstag>, --cvstag <cvstag>
257 - build package using resources from specified CVS tag,
5323fffd 258-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
259-R, --fetch-build-requires
260 - fetch what is BuildRequired,
261-RB, --remove-build-requires
262 - remove all you fetched with -R or --fetch-build-requires
263 remember, this option requires confirmation,
264-FRB, --force-remove-build-requires
265 - remove all you fetched with -R or --fetch-build-requires
266 remember, this option works without confirmation,
06541433
JR
267-sd, --source-distfiles - list sources available from distfiles (intended for offline
268 operations; does not work when Icon field is present
269 but icon file is absent),
270-sdp, --source-distfiles-paths - list sources available from distfiles -
271 paths relative to distfiles directory (intended for offline
272 operations; does not work when Icon field is present
273 but icon file is absent),
a7eefc54 274-sf, --source-files - list sources - bare filenames (intended for offline
275 operations; does not work when Icon field is present
3621e588 276 but icon file is absent),
a7eefc54 277-sp, --source-paths - list sources - filenames with full local paths (intended for
278 offline operations; does not work when Icon field is present
3621e588 279 but icon file is absent),
2dddf439
ER
280-su, --source-urls - list urls - urls to sources and patches
281 intended for copying urls with spec with lots of macros in urls
cd445739
AM
282-T <cvstag> , --tag <cvstag>
283 - add cvs tag <cvstag> for files,
284-Tvs, --tag-version-stable
094bd95b 285 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
286-Ts, --tag-stable
287 - add cvs tag STABLE for files,
cd445739 288-Tv, --tag-version
1691a37b 289 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
290-Tp, --tag-prefix <prefix>
291 - add <prefix> to NAME-VERSION-RELEASE tags,
292-tt, --test-tag <prefix>
293 - fail if tag is already present,
50321881
JK
294-ir, --integer-release-only
295 - allow only integer and snapshot releases
cd445739
AM
296-v, --verbose - be verbose,
297-u, --try-upgrade - check version, and try to upgrade package
298-un, --try-upgrade-with-float-version
299 - as above, but allow float version
deccc50e 300-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
301-Upi, --update-poldek-indexes
302 - refresh or make poldek package index files.
c890b916 303-np, --nopatch <patchnumber>
bed98670 304 - don't apply <patchnumber>
dfe2cb9a
MK
305--show-bconds - show available conditional builds, which can be used
306 - with --with and/or --without switches.
9b78be50
ER
307--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
308 ./repackage.sh script. in other words, the output is
309 parseable by scripts.
cd445739
AM
310--with/--without <feature>
311 - conditional build package depending on %_with_<feature>/
312 %_without_<feature> macro switch. You may now use
313 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
314 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 315--target <platform>, --target=<platform>
3621e588
ER
316 - build for platform <platform>.
317--init-rpm-dir - initialize ~/rpm directory structure
5a491465 318"
319}
320
c890b916 321update_shell_title() {
a0d6396b 322 [ -t 1 ] || return
0b65d15e
ER
323 local len=${COLUMNS:-80}
324 local msg=$(echo "$*" | cut -c-$len)
325
e225de91
ER
326 if [ -n "$BE_VERBOSE" ]; then
327 echo >&2 "$(date +%s.%N) $*"
328 fi
329
982e358c 330 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
331 local pkg
332 if [ -n "$PACKAGE_NAME" ]; then
333 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
334 else
335 pkg=${SPECFILE}
336 fi
337
338 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 339 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
340 case "$TERM" in
341 cygwin|xterm*)
342 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
343 ;;
344 screen*)
345 echo >&2 -ne "\033]0;$msg\007"
346 ;;
347 esac
348 fi
c890b916
ER
349}
350
7e40520f
ER
351# set TARGET from BuildArch: from SPECFILE
352set_spec_target() {
ce40491a
ER
353 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
354 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
355 if [ "$tmp" ]; then
7e40520f
ER
356 TARGET="$tmp"
357 case "$RPMBUILD" in
358 "rpmbuild")
ce40491a 359 TARGET_SWITCH="--target $TARGET" ;;
7e40520f 360 "rpm")
ce40491a 361 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 362 esac
ce40491a
ER
363 fi
364 fi
7e40520f
ER
365}
366
cd445739 367cache_rpm_dump () {
d22150da 368 if [ -n "$DEBUG" ]; then
518ff1fb
ER
369 set -x
370 set -v
d22150da 371 fi
7e40520f 372
13974367 373 update_shell_title "cache_rpm_dump"
237bd3f1
ER
374 local rpm_dump
375 rpm_dump=`
d05e8080 376
fa4bf1df 377 # we reset macros not to contain macros.build as all the %() macros are
559d511f 378 # executed here, while none of them are actually needed.
fa4bf1df 379 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
559d511f 380 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
36433112 381 macrofiles="/usr/lib/rpm/macros:$SPECS_DIR/.builder-rpmmacros:~/etc/.rpmmacros:~/.rpmmacros"
237bd3f1 382 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
8ebeba63
AM
383 if [ -f /usr/lib/rpm/rpmrc ]; then
384 # FIXME: better ideas than .rpmrc?
385 printf 'include:/usr/lib/rpm/rpmrc\nmacrofiles:%s\n' $macrofiles > .builder-rpmrc
386 else
387 printf 'macrofiles:%s\n' $macrofiles > .builder-rpmrc
388 fi
fb198857 389# TODO: move these to /usr/lib/rpm/macros
36433112 390 cat > .builder-rpmmacros <<'EOF'
f78a0bb7 391%alt_kernel %{nil}
392%_alt_kernel %{nil}
fb198857
ER
393%requires_releq_kernel_up %{nil}
394%requires_releq_kernel_smp %{nil}
6b8134e3 395%requires_releq() %{nil}
bb01dee9 396%pyrequires_eq() %{nil}
559d511f 397%requires_eq() %{nil}
c13be3d1 398%requires_eq_to() %{nil}
fb198857
ER
399%releq_kernel_up ERROR
400%releq_kernel_smp ERROR
74d9fd14 401%kgcc_package ERROR
237bd3f1 402%_fontsdir ERROR
7141278d 403%ruby_version ERROR
404%ruby_ver_requires_eq() %{nil}
405%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 406%__php_api_requires() %{nil}
7141278d 407%php_major_version ERROR
408%php_api_version ERROR
409%py_ver ERROR
41035426
ER
410%perl_vendorarch ERROR
411%perl_vendorlib ERROR
703ae20b
ER
412# damn. need it here! - copied from /usr/lib/rpm/macros.build
413%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
414%patchset_source(f:b:) %(
415 base=%{-b*}%{!-b*:10000};
416 start=$(expr $base + %1);
417 end=$(expr $base + %{?2}%{!?2:%{1}});
418 # we need to call seq twice as it doesn't allow two formats
419 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
420 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
421 paste %{tmpdir}/__ps{1,2};
422 rm -f %{tmpdir}/__ps{1,2};
423) \
424%{nil}
fb198857 425EOF
cd445739 426 case "$RPMBUILD" in
237bd3f1
ER
427 rpm)
428 ARGS='-bp'
429 ;;
430 rpmbuild)
431 ARGS='--nodigest --nosignature --nobuild'
432 ;;
433 esac
3d12d055
JR
434 if [ "$NOINIT" = "yes" ] ; then
435 cat >> .builder-rpmmacros <<'EOF'
436%_specdir ./
437%_sourcedir ./
438EOF
c039643c
JR
439 fi
440 $RPMBUILD --rcfile .builder-rpmrc $ARGS $ARGDIRS --nodeps --define "prep $dump" $BCOND $TARGET_SWITCH $SPECFILE 2>&1
237bd3f1 441 `
fb198857 442 if [ $? -gt 0 ]; then
237bd3f1
ER
443 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
444 echo "$error" >&2
518ff1fb 445 Exit_error err_build_fail
fb198857 446 fi
d05e8080
ER
447
448 # make small dump cache
449 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
450 $2 ~ /^SOURCEURL/ {print}
451 $2 ~ /^PATCHURL/ {print}
452 $2 ~ /^nosource/ {print}
453 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
454 '`
455
13974367 456 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
457}
458
459rpm_dump () {
460 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 461 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
462 fi
463 echo "$rpm_dump_cache"
464}
465
d05e8080
ER
466get_icons()
467{
468 update_shell_title "get icons"
469 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
470 if [ -z "$ICONS" ]; then
471 return
472 fi
473
975d7b23 474 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
475}
476
59398507 477parse_spec()
478{
af4d5315 479 update_shell_title "parsing specfile"
cd445739 480 if [ -n "$DEBUG" ]; then
518ff1fb
ER
481 set -x
482 set -v
cd445739 483 fi
b2975fc3 484
d05e8080 485 # icons are needed for successful spec parse
518ff1fb 486 get_icons
d05e8080 487
cd445739 488 cd $SPECS_DIR
cd445739 489 cache_rpm_dump
00fcec7e 490
cd445739
AM
491 if [ "$NOSRCS" != "yes" ]; then
492 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
493 fi
7cb24972 494
cd445739
AM
495 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
496 FAIL_IF_NO_SOURCES="no"
497 fi
498
499 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
500 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
fa4bf1df
ER
501 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3}')
502 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3}')
503 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3}')
78eab2a1 504
cd445739
AM
505 if [ -n "$BE_VERBOSE" ]; then
506 echo "- Sources : `nourl $SOURCES`"
507 if [ -n "$PATCHES" ]; then
508 echo "- Patches : `nourl $PATCHES`"
509 else
510 echo "- Patches : *no patches needed*"
511 fi
512 if [ -n "$ICONS" ]; then
513 echo "- Icon : `nourl $ICONS`"
514 else
515 echo "- Icon : *no package icon*"
516 fi
517 echo "- Name : $PACKAGE_NAME"
518 echo "- Version : $PACKAGE_VERSION"
519 echo "- Release : $PACKAGE_RELEASE"
520 fi
13974367
ER
521
522 update_shell_title "parse_spec: OK!"
cd445739
AM
523}
524
525Exit_error()
526{
527 if [ -n "$DEBUG" ]; then
518ff1fb
ER
528 set -x
529 set -v
cd445739
AM
530 fi
531
532 cd "$__PWD"
533
534 case "$1" in
535 "err_no_spec_in_cmdl" )
536 remove_build_requires
518ff1fb 537 echo "ERROR: spec file name not specified."
cd445739
AM
538 exit 2 ;;
539 "err_no_spec_in_repo" )
540 remove_build_requires
518ff1fb 541 echo "Error: spec file not stored in CVS repo."
cd445739
AM
542 exit 3 ;;
543 "err_no_source_in_repo" )
544 remove_build_requires
518ff1fb 545 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
546 exit 4 ;;
547 "err_build_fail" )
548 remove_build_requires
518ff1fb 549 echo "Error: package build failed. (${2:-no more info})"
cd445739 550 exit 5 ;;
78eab2a1
AM
551 "err_no_package_data" )
552 remove_build_requires
553 echo "Error: couldn't get out package name/version/release from spec file."
554 exit 6 ;;
ce40491a 555 "err_tag_exists" )
50321881 556 remove_build_requires
518ff1fb 557 echo "Tag ${2} already exists (spec release: ${3})."
50321881 558 exit 9 ;;
ce40491a 559 "err_fract_rel" )
50321881 560 remove_build_requires
518ff1fb 561 echo "Release ${2} not integer and not a snapshot."
50321881 562 exit 10 ;;
fb96e0b5
AM
563 "err_branch_exists" )
564 remove_build_requires
518ff1fb 565 echo "Tree branch already exists (${2})."
fb96e0b5 566 exit 11 ;;
50321881 567
cd445739 568 esac
73848362
ER
569 echo "Unknown error."
570 exit 100
cd445739
AM
571}
572
573init_builder()
574{
575 if [ -n "$DEBUG" ]; then
518ff1fb
ER
576 set -x
577 set -v
0dd6320d 578 fi
cd445739 579
4aeb9973 580 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
581 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
582 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
583 else
584 SOURCE_DIR="."
585 SPECS_DIR="."
586 fi
cd445739
AM
587
588 __PWD="`pwd`"
00fcec7e 589}
590
d6a77ddb 591get_spec()
1471f6d6 592{
c890b916 593
2e5be021 594 update_shell_title "get_spec"
c890b916 595
cd445739 596 if [ -n "$DEBUG" ]; then
518ff1fb
ER
597 set -x
598 set -v
cd445739
AM
599 fi
600
601 cd "$SPECS_DIR"
049ab214 602 if [ ! -f "$SPECFILE" ]; then
518ff1fb 603 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
604 fi
605 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 606
049ab214
ER
607 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
608 echo "Warning: No CVS access defined - using local .spec file"
609 NOCVSSPEC="yes"
cd445739
AM
610 fi
611
049ab214 612 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 613 fi
049ab214 614
cd445739 615 if [ ! -f "$SPECFILE" ]; then
518ff1fb 616 Exit_error err_no_spec_in_repo
cd445739
AM
617 fi
618
619 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
620 chmod $CHMOD_MODE $SPECFILE
621 fi
622 unset OPTIONS
a7eefc54 623 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 624
ce40491a 625 set_spec_target
cd445739
AM
626}
627
628find_mirror()
629{
630 cd "$SPECS_DIR"
782518da 631 local url="$1"
cd445739
AM
632 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
633 cvs update mirrors >&2
634 fi
635
636 IFS="|"
782518da
ER
637 local origin mirror name rest ol prefix
638 while read origin mirror name rest; do
639 # skip comments and empty lines
640 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
641 continue
642 fi
cd445739
AM
643 ol=`echo -n "$origin"|wc -c`
644 prefix="`echo -n "$url" | head -c $ol`"
645 if [ "$prefix" = "$origin" ] ; then
782518da 646 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
647 echo -n "$mirror$suffix"
648 return 0
649 fi
650 done < mirrors
651 echo "$url"
652}
653
e7e0d4ec 654# Warning: unpredictable results if same URL used twice
cd445739
AM
655src_no ()
656{
657 cd $SPECS_DIR
658 rpm_dump | \
659 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
660 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
661 head -n 1 | xargs
1471f6d6 662}
663
e7e0d4ec 664src_md5()
8ba5cdda 665{
e7e0d4ec 666 [ "$NO5" = "yes" ] && return
cd445739
AM
667 no=$(src_no "$1")
668 [ -z "$no" ] && return
669 cd $SPECS_DIR
e7e0d4ec
ER
670 local md5
671
672 if [ -f additional-md5sums ]; then
673 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
674 if [ -z "$spec_rev" ]; then
675 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
676 fi
677 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
678 md5=$(grep -s -v '^#' additional-md5sums | \
679 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
680 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
681 grep -E '^[0-9a-f]{32}$')
682
683 if [ "$md5" ]; then
684 if [ $(echo "$md5" | wc -l) != 1 ] ; then
685 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
686 fi
687 echo "$md5" | tail -n 1
688 return
689 fi
cd445739 690 fi
e7e0d4ec
ER
691
692 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
693 if [ -n "$source_md5" ]; then
694 echo $source_md5
cd445739 695 else
e7e0d4ec
ER
696 # we have empty SourceX-md5, but it is still possible
697 # that we have NoSourceX-md5 AND NoSource: X
698 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 699 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 700 echo $nosource_md5
cd445739 701 fi
cd445739
AM
702 fi
703}
704
06541433
JR
705distfiles_path ()
706{
707 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
708}
709
cd445739
AM
710distfiles_url ()
711{
06541433 712 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
713}
714
715distfiles_attic_url ()
716{
06541433 717 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
718}
719
720good_md5 ()
721{
722 md5=$(src_md5 "$1")
723 [ "$md5" = "" ] || \
724 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
725}
726
a4b50627
AF
727good_size ()
728{
ce40491a
ER
729 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
730 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
731}
732
947025e5 733cvsignore_df ()
734{
735 if [ "$CVSIGNORE_DF" != "yes" ]; then
736 return
737 fi
738 cvsignore=${SOURCE_DIR}/.cvsignore
739 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
740 echo "$1" >> $cvsignore
741 fi
742}
743
e7fa3b9f
ER
744cvsup()
745{
ce40491a
ER
746 update_shell_title "cvsup"
747 local OPTIONS="up "
748 if [ -n "$CVSROOT" ]; then
749 OPTIONS="-d $CVSROOT $OPTIONS"
750 fi
b1c6aace 751
ce40491a
ER
752 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
753 OPTIONS="$OPTIONS -A"
754 else
755 if [ -n "$CVSDATE" ]; then
756 OPTIONS="$OPTIONS -D $CVSDATE"
757 fi
758 if [ -n "$CVSTAG" ]; then
759 OPTIONS="$OPTIONS -r $CVSTAG"
760 fi
761 fi
e7fa3b9f 762
ce40491a
ER
763 local result=1
764 local retries_counter=0
765 if [ $# = 1 ]; then
766 update_shell_title "cvsup: $*"
767 else
768 update_shell_title "cvsup: $# files"
769 fi
770 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
771 retries_counter=$(( $retries_counter + 1 ))
772 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
773 result=$?
774 [ -n "$output" ] && echo "$output"
775 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
776 echo "Trying again [$*]... ($retries_counter)"
777 update_shell_title "cvsup: retry #$retries_counter"
778 sleep 2
779 continue
780 else
781 break
782 fi
783 done
784 update_shell_title "cvsup: done!"
785 return $result
e7fa3b9f
ER
786}
787
71f8e908
ER
788# returns true if "$1" is ftp, http or https protocol url
789is_url()
790{
791 case "$1" in
792 ftp://*|http://*|https://*)
793 return 0
794 ;;
795 esac
796 return 1
797}
798
ecba6ad5
ER
799update_md5()
800{
801 if [ $# -eq 0 ]; then
802 return
803 fi
804
805 update_shell_title "update md5"
806 if [ -n "$DEBUG" ]; then
518ff1fb
ER
807 set -x
808 set -v
ecba6ad5
ER
809 fi
810
811 cd "$SOURCE_DIR"
812
813 # pass 1: check files to be fetched
814 local todo
815 local need_files
816 for i in "$@"; do
817 local fp=$(nourl "$i")
818 local srcno=$(src_no "$i")
6392b5fd
ER
819 if [ -n "$ADD5" ]; then
820 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
821 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
822 else
823 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
824 fi
825 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
826 need_files="$need_files $i"
827 fi
828 done
829
830 # pass 1a: get needed files
831 if [ "$need_files" ]; then
832 get_files $need_files
833 fi
834
835 # pass 2: proceed with md5 adding or updating
836 for i in "$@"; do
837 local fp=$(nourl "$i")
838 local srcno=$(src_no "$i")
71f8e908
ER
839 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
840 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
841 local tag="Source$srcno-md5"
842 if [[ "$md5" == *NoSource* ]]; then
843 tag="NoSource$srcno-md5"
844 fi
ecba6ad5 845 md5=$(md5sum "$fp" | cut -f1 -d' ')
4efa0b98 846 echo "Updating $tag ($md5: $fp)."
ecba6ad5 847 perl -i -ne '
71f8e908
ER
848 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
849 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
850 ' \
851 $SPECS_DIR/$SPECFILE
852 fi
853 done
854}
855
856check_md5()
857{
858 update_shell_title "check md5"
859
860 for i in "$@"; do
861 if good_md5 "$i" && good_size "$i"; then
862 continue
863 fi
864
865 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
866 echo "or -5 to update md5 sums, if you're sure files are correct."
867 Exit_error err_no_source_in_repo $i
868 done
869}
870
cd445739
AM
871get_files()
872{
7cb24972 873 update_shell_title "get_files"
cd445739
AM
874
875 if [ -n "$DEBUG" ]; then
518ff1fb
ER
876 set -x
877 set -v
cd445739
AM
878 fi
879
f09c0772 880 if [ $# -gt 0 ]; then
cd445739
AM
881 cd "$SOURCE_DIR"
882
b1c6aace 883 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 884 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
885 NOCVS="yes"
886 fi
887
f2e42a41 888 local nc=0
e7fa3b9f 889 local get_files_cvs=""
3815b69a 890 for i in "$@"; do
f2e42a41 891 nc=$((nc + 1))
dcebdffb 892 local cvsup=0
3815b69a 893 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 894 update_shell_title "$i"
f09c0772 895 local fp=`nourl "$i"`
ecba6ad5 896 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 897 continue
18e5347d 898 fi
ecba6ad5 899
cd445739 900 FROM_DISTFILES=0
e7e0d4ec 901 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
902
903 # we know if source/patch is present in cvs/distfiles
904 # - has md5 (in distfiles)
905 # - in cvs... ideas?
906
907 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 908 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
909 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
910 echo "Warning: no URL given for $i"
911 fi
912
e7e0d4ec 913 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 914 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 915 echo "$fp having proper md5sum already exists"
cd445739
AM
916 continue
917 fi
4ea1c265 918 target="$fp"
28b34560
ER
919
920 # prefer mirror over distfiles if there's mirror
921 # TODO: build url list and then try each url from the list
922 if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
923 url="$im"
924 else
925 url=$(distfiles_url "$i")
926 fi
927
cd445739
AM
928 url_attic=$(distfiles_attic_url "$i")
929 FROM_DISTFILES=1
ecba6ad5
ER
930 # is $url local file?
931 if [[ "$url" = [./]* ]]; then
18a52930 932 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
933 ${GETLOCAL} $url $target
934 else
935 if [ -z "$NOMIRRORS" ]; then
9e9f8920 936 url=$(find_mirror "$url")
cd445739 937 fi
9e9f8920
ER
938
939 local uri=${url}
940 # make shorter message for distfiles urls
941 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
942 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
943 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
944 uri="df: $uri"
945 fi
946 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 947 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 948 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 949 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 950 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
951 fi
952 fi
ecba6ad5
ER
953
954 # is it empty file?
955 if [ ! -s "$target" ]; then
cd445739
AM
956 rm -f "$target"
957 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 958 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
959 ${GETLOCAL} $url_attic $target
960 else
961 if [ -z "$NOMIRRORS" ]; then
962 url_attic="`find_mirror "$url_attic"`"
963 fi
18a52930 964 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 965 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 966 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 967 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 968 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
969 fi
970 fi
971 fi
ecba6ad5
ER
972
973 if [ -s "$target" ]; then
947025e5 974 cvsignore_df $target
975 else
cd445739
AM
976 rm -f "$target"
977 FROM_DISTFILES=0
978 fi
e7e0d4ec 979 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
980 if [ $# -gt 1 ]; then
981 get_files_cvs="$get_files_cvs $fp"
982 update_shell_title "$fp (will cvs up later)"
983 cvsup=1
984 else
985 cvsup $fp
986 fi
cd445739
AM
987 fi
988
f09c0772 989 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
990 if [ -z "$NOMIRRORS" ]; then
991 im="`find_mirror "$i"`"
992 else
993 im="$i"
994 fi
ce40491a 995 update_shell_title "${GETURI%% *}: $im"
cd445739 996 ${GETURI} "$im" || \
33da77c4 997 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 998 update_shell_title "${GETURI2%% *}: $im"
cd445739 999 ${GETURI2} "$im"
7e365483 1000 fi
cd445739
AM
1001 fi
1002
dcebdffb
ER
1003 if [ "$cvsup" = 1 ]; then
1004 continue
1005 fi
1006
cd445739 1007 fi
ecba6ad5
ER
1008
1009 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1010 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 1011 Exit_error err_no_source_in_repo $i
cd445739 1012 fi
2a5f078d 1013
ecba6ad5 1014 # we check md5 here just only to refetch immediately
a4b50627 1015 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1016 :
1017 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1018 # wrong md5 from distfiles: remove the file and try again
cd445739 1019 # but only once ...
deccc50e 1020 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1021 FROM_DISTFILES=2
1022 rm -f $target
18a52930 1023 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1024 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1025 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1026 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1027 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1028 fi
ecba6ad5 1029 if [ ! -s "$target" ]; then
cd445739 1030 rm -f "$target"
18a52930 1031 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1032 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1033 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1034 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1035 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1036 fi
1037 fi
1038 test -s "$target" || rm -f "$target"
1039 fi
cd445739 1040 done
e7fa3b9f
ER
1041 SHELL_TITLE_PREFIX=""
1042
1043 if [ "$get_files_cvs" ]; then
ce40491a 1044 cvsup $get_files_cvs
e7fa3b9f 1045 fi
cd445739
AM
1046
1047 if [ "$CHMOD" = "yes" ]; then
3815b69a 1048 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1049 if [ -n "$CHMOD_FILES" ]; then
1050 chmod $CHMOD_MODE $CHMOD_FILES
1051 fi
1052 fi
cd445739
AM
1053 fi
1054}
1055
1056make_tagver() {
ce40491a 1057 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1058 set -x
1059 set -v
ce40491a 1060 fi
78eab2a1 1061
ce40491a
ER
1062 # Check whether first character of PACKAGE_NAME is legal for tag name
1063 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1064 TAG_PREFIX=tag_
1065 fi
1066 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
1067 # Remove #kernel.version_release from TAGVER because tagging sources
1068 # could occur with different kernel-headers than kernel-headers used at build time.
1069 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
1070 echo -n "$TAGVER"
cd445739
AM
1071}
1072
1073tag_files()
1074{
1075 TAG_FILES="$@"
1076
1077 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1078 set -x
1079 set -v
cd445739
AM
1080 fi
1081
73ef63d8
ER
1082 echo "Version: $PACKAGE_VERSION"
1083 echo "Release: $PACKAGE_RELEASE"
cd445739 1084
73ef63d8 1085 TAGVER=`make_tagver`
cd445739 1086
73ef63d8
ER
1087 if [ "$TAG_VERSION" = "yes" ]; then
1088 echo "CVS tag: $TAGVER"
1089 fi
1090 if [ -n "$TAG" ]; then
1091 echo "CVS tag: $TAG"
1092 fi
cd445739 1093
39dcc7de 1094 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1095 if [ -n "$CVSROOT" ]; then
1096 OPTIONS="-d $CVSROOT $OPTIONS"
1097 fi
cd445739 1098
73ef63d8
ER
1099 cd "$SOURCE_DIR"
1100 local tag_files
1101 for i in $TAG_FILES; do
1102 # don't tag files stored on distfiles
1103 [ -n "`src_md5 $i`" ] && continue
1104 local fp=`nourl "$i"`
1105 if [ -f "$fp" ]; then
1106 tag_files="$tag_files $fp"
1107 else
1108 Exit_error err_no_source_in_repo $i
03db3356 1109 fi
73ef63d8 1110 done
03db3356 1111
73ef63d8 1112 if [ "$tag_files" ]; then
cd445739 1113 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8
ER
1114 update_shell_title "tag sources: $TAGVER"
1115 cvs $OPTIONS $TAGVER $tag_files
cd445739
AM
1116 fi
1117 if [ -n "$TAG" ]; then
73ef63d8
ER
1118 update_shell_title "tag sources: $TAG"
1119 cvs $OPTIONS $TAG $tag_files
cd445739 1120 fi
73ef63d8
ER
1121 fi
1122
1123 cd "$SPECS_DIR"
1124 if [ "$TAG_VERSION" = "yes" ]; then
1125 update_shell_title "tag spec: $TAGVER"
1126 cvs $OPTIONS $TAGVER $SPECFILE
1127 fi
1128 if [ -n "$TAG" ]; then
1129 update_shell_title "tag spec: $TAG"
1130 cvs $OPTIONS $TAG $SPECFILE
1131 fi
cd445739
AM
1132}
1133
1134branch_files()
1135{
1136 TAG=$1
1137 echo "CVS branch tag: $TAG"
518ff1fb 1138 shift
cd445739
AM
1139
1140 TAG_FILES="$@"
1141
1142 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1143 set -x
1144 set -v
cd445739
AM
1145 fi
1146
78a5a506
ER
1147 local OPTIONS="tag $CVS_FORCE -b"
1148 if [ -n "$CVSROOT" ]; then
1149 OPTIONS="-d $CVSROOT $OPTIONS"
1150 fi
1151 cd "$SOURCE_DIR"
1152 local tag_files
1153 for i in $TAG_FILES; do
1154 local fp=`nourl "$i"`
1155 if [ -f "$fp" ]; then
1156 tag_files="$tag_files $fp"
1157 else
1158 Exit_error err_no_source_in_repo $i
c10fa4fa 1159 fi
78a5a506
ER
1160 done
1161 if [ "$tag_files" ]; then
1162 cvs $OPTIONS $TAG $tag_files
1163 fi
c10fa4fa 1164
78a5a506
ER
1165 cd "$SPECS_DIR"
1166 cvs $OPTIONS $TAG $SPECFILE
cd445739
AM
1167}
1168
1169
1170
59398507 1171build_package()
1172{
2e5be021 1173 update_shell_title "build_package"
cd445739 1174 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1175 set -x
1176 set -v
cd445739 1177 fi
5a491465 1178
cd445739
AM
1179 cd "$SPECS_DIR"
1180
1181 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1182 update_shell_title "build_package: try_upgrade"
cd445739 1183 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1184 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1185 else
cc538c24 1186 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1187 fi
1188
1189 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1190
1191 if [ -n "$TNEWVER" ]; then
1192 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1193 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1194 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1195 cp -f $SPECFILE $SPECFILE.bak
1196 fi
cd445739
AM
1197 chmod +w $SPECFILE
1198 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1199 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1200 parse_spec
1201 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1202 update_md5 $SOURCES
975d7b23 1203
cd445739
AM
1204 unset TOLDVER TNEWVER TNOTIFY
1205 fi
1206 fi
1207 cd "$SPECS_DIR"
2a5f078d 1208
cd445739
AM
1209 case "$COMMAND" in
1210 build )
1211 BUILD_SWITCH="-ba" ;;
1212 build-binary )
1213 BUILD_SWITCH="-bb" ;;
1214 build-source )
1215 BUILD_SWITCH="-bs --nodeps" ;;
1216 build-prep )
1217 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1218 build-build )
1219 BUILD_SWITCH="-bc" ;;
1220 build-install )
1221 BUILD_SWITCH="-bi" ;;
1222 build-list )
1223 BUILD_SWITCH="-bl" ;;
1224
cd445739 1225 esac
c890b916 1226
2e5be021 1227 update_shell_title "build_package: $COMMAND"
cd445739
AM
1228 if [ -n "$LOGFILE" ]; then
1229 LOG=`eval echo $LOGFILE`
1230 if [ -d "$LOG" ]; then
1231 echo "Log file $LOG is a directory."
1232 echo "Parse error in the spec?"
518ff1fb 1233 Exit_error err_build_fail
cd445739
AM
1234 fi
1235 if [ -n "$LASTLOG_FILE" ]; then
1236 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1237 fi
1238 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1239 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1240 RETVAL=`cat $RES_FILE`
1241 rm $RES_FILE
1242 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1243 if [ "$RETVAL" -eq "0" ]; then
1244 mv $LOG $LOGDIROK
1245 else
1246 mv $LOG $LOGDIRFAIL
1247 fi
1248 fi
8ba5cdda 1249 else
86aafdbe 1250 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1251 RETVAL=$?
8ba5cdda 1252 fi
cd445739
AM
1253 if [ "$RETVAL" -ne "0" ]; then
1254 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1255 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1256 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1257 mv -f $SPECFILE.bak $SPECFILE
1258 fi
cd445739 1259 fi
518ff1fb 1260 Exit_error err_build_fail
cd445739
AM
1261 fi
1262 unset BUILD_SWITCH
1263}
1264
1265nourl()
1266{
1267 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1268}
1269
cd445739
AM
1270install_required_packages()
1271{
1272 run_poldek -vi $1
1273 return $?
1274}
1275
fa4bf1df
ER
1276find_spec_bcond() {
1277 # taken from find-spec-bcond, but with just getting the list
1278 local SPEC="$1"
1279 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1280 awk -F"\n" '
1281 /^%changelog/ { exit }
1282 /_with(out)?_[_a-zA-Z0-9]+/{
1283 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1284 print substr($0, RSTART, RLENGTH);
1285 }
1286 /^%bcond_with/{
1287 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1288 bcond = substr($0, RSTART +5 , RLENGTH -5);
1289 gsub(/[ \t]+/,"_",bcond);
1290 print bcond
1291 }' $SPEC | LC_ALL=C sort -u
1292}
1293
117d9861 1294process_bcondrc() {
301cbfd4
ER
1295 # expand bconds from ~/.bcondrc
1296 # The file structure is like gentoo's package.use:
1297 # ---
1298 # * -selinux
1299 # samba -mysql -pgsql
47a8df12 1300 # w32codec-installer license_agreement
301cbfd4
ER
1301 # php +mysqli
1302 # ---
fa4bf1df 1303 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1304 :
1305 else
1306 return
1307 fi
301cbfd4 1308
117d9861 1309 SN=${SPECFILE%%\.spec}
c8a3e2ac 1310
117d9861
ER
1311 local bcondrc=$HOME/.bcondrc
1312 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1313
117d9861 1314 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1315
117d9861
ER
1316 while read pkg flags; do
1317 # ignore comments
1318 [[ "$pkg" == \#* ]] && continue
1319
1320 # any package or current package?
1321 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1322 for flag in $flags; do
1323 local opt=${flag#[+-]}
1324
1325 # use only flags which are in this package.
1326 if [[ $bcond_avail = *${opt}* ]]; then
1327 if [[ $flag = -* ]]; then
1328 if [[ $BCOND != *--with?${opt}* ]]; then
1329 BCOND="$BCOND --without $opt"
1330 fi
1331 else
1332 if [[ $BCOND != *--without?${opt}* ]]; then
1333 BCOND="$BCOND --with $opt"
301cbfd4
ER
1334 fi
1335 fi
117d9861
ER
1336 fi
1337 done
1338 fi
1339 done < $bcondrc
1340 update_shell_title "parse ~/.bcondrc: DONE!"
1341}
1342
1343set_bconds_values()
1344{
1345 update_shell_title "set bcond values"
1346
1347 AVAIL_BCONDS_WITHOUT=""
1348 AVAIL_BCONDS_WITH=""
1349 if `grep -q ^%bcond ${SPECFILE}`; then
1350 BCOND_VERSION="NEW"
1351 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1352 BCOND_VERSION="OLD"
1353 else
1354 return
301cbfd4
ER
1355 fi
1356
117d9861
ER
1357 local bcond_avail=$(find_spec_bcond $SPECFILE)
1358 process_bcondrc "$SPECFILE"
1359
fa4bf1df 1360 update_shell_title "parse bconds"
cd445739 1361 case "${BCOND_VERSION}" in
fa4bf1df 1362 NONE)
7e365483 1363 :
cd445739 1364 ;;
7e365483 1365 OLD)
cd445739 1366 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1367 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1368 do
fa4bf1df
ER
1369 AVAIL_BCOND_WITHOUT=${opt#_without_}
1370 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1371 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1372 else
1373 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1374 fi
1375 done
2a5f078d 1376
fa4bf1df 1377 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1378 do
fa4bf1df
ER
1379 AVAIL_BCOND_WITH=${opt#_with_}
1380 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1381 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1382 else
1383 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1384 fi
1385 done
1386 ;;
1387 NEW)
fa4bf1df
ER
1388 local cond_type="" # with || without
1389 for opt in $bcond_avail; do
cd445739
AM
1390 case "$opt" in
1391 _without)
1392 cond_type="without"
1393 ;;
1394 _with)
1395 cond_type="with"
1396 ;;
f8d24cee 1397 _without_*)
fa4bf1df
ER
1398 AVAIL_BCOND_WITHOUT=${opt#_without_}
1399 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1400 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1401 else
1402 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1403 fi
1404 ;;
1405 _with_*)
fa4bf1df
ER
1406 AVAIL_BCOND_WITH=${opt#_with_}
1407 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1408 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1409 else
1410 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1411 fi
1412 ;;
cd445739
AM
1413 *)
1414 case "$cond_type" in
1415 with)
1416 cond_type=''
1417 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1418 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1419 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1420 else
1421 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1422 fi
7e365483 1423 ;;
cd445739
AM
1424 without)
1425 cond_type=''
1426 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1427 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1428 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1429 else
1430 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1431 fi
1432 ;;
1433 esac
1434 ;;
1435 esac
1436 done
1437 ;;
1438 esac
1439}
1440
1441run_sub_builder()
1442{
1443 package_name="${1}"
af6b168f 1444 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1445 #
1446